
#include "stdafx.h"
#include "myclassscript.h" // Edit this file to configure your script interface

#pragma warning(disable:4100)

// ---------------------------------------------------------------------------------
CMyClass::CMyClass() 
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::CMyClass called.");

	srand((unsigned)time(NULL));

	m_TheCallback.wcsMove.clear();
	m_TheCallback.wcsCallback.clear();
}

// ---------------------------------------------------------------------------------
CMyClass::~CMyClass()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::~CMyClass called.");
}

// Return pointers to the script class defined in script.h
// ---------------------------------------------------------------------------------
BOOL CMyClass::GetJSClass(JSClass** ppJSClass, JSPropertySpec** ppJSProps, JSFunctionSpec** ppJSMethods, void** ppPrivate)
// ---------------------------------------------------------------------------------
{
	//GL_WriteDebugOut(L"CMyClass::GetJSClass called.");
	
	*ppJSClass   = &myclass_class; 
	*ppJSProps   = myclass_props;  
	*ppJSMethods = myclass_methods;
	*ppPrivate   = (void*) this;   

	return TRUE;
}

// ---------------------------------------------------------------------------------
BOOL CMyClass::DocumentLoaded()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::DocumentLoaded called.");

	return FALSE;
}

// ---------------------------------------------------------------------------------
void CMyClass::DocumentDestroy()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::DocumentDestroy called.");
	mychess.CloseWorkerThread();
}

// ---------------------------------------------------------------------------------
void CMyClass::DeviceLost()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::DeviceLost called.");
}

// ---------------------------------------------------------------------------------
void CMyClass::DeviceRestore()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::DeviceRestore called.");
}

// ---------------------------------------------------------------------------------
void CMyClass::Update(float seconds)
// ---------------------------------------------------------------------------------
{
	//GL_WriteDebugOut(L"CMyClass::Update called.");
	
	if (m_TheCallback.wcsMove.empty() || m_TheCallback.wcsCallback.empty()) return;

	RiseCallback();
}

// ---------------------------------------------------------------------------------
void CMyClass::SetCallback(std::wstring wcsCallback, std::wstring wcsMove)
// ---------------------------------------------------------------------------------
{
	//GL_WriteDebugOut(L"CMyClass::RiseCallback called.");

	m_TheCallback.wcsCallback = wcsCallback;
	m_TheCallback.wcsMove = wcsMove;
}

// ---------------------------------------------------------------------------------
void CMyClass::RiseCallback()
// ---------------------------------------------------------------------------------
{
	//GL_WriteDebugOut(L"CMyClass::RiseCallback called.");

	EnterCriticalSection(g_pInfo->pJSCS);

	jsval rval;	
	uintN iLineNo = 0;
	const char* sFilename = "[DXSMiKoChess Plugin]";

	WCHAR wcsDummy[1024];
	memset(wcsDummy,0,sizeof(wcsDummy));
	swprintf(wcsDummy,1023,L"%s(\"%s\");",m_TheCallback.wcsCallback.c_str(),m_TheCallback.wcsMove.c_str());

	JSBool bRet = JS_EvaluateUCScript(g_pInfo->pJSContext,
									  JS_GetGlobalObject(g_pInfo->pJSContext),
									  (const jschar*) wcsDummy,
									  wcslen(wcsDummy),
									  sFilename,
									  iLineNo,
									  &rval);

	if (bRet!=JS_TRUE)
	{
		GL_WriteDebugOut(L"CMyClass::RiseCallback ERROR on JS_EvaluateUCScript.");
	}

	LeaveCriticalSection(g_pInfo->pJSCS);

	// Clear the callback container. Only call into DXStudio once
	m_TheCallback.wcsMove.clear();
	m_TheCallback.wcsCallback.clear();
}

// ---------------------------------------------------------------------------------
bool CMyClass::NewGame()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::NewGame called.");
	return(mychess.NewGame());
}

// ---------------------------------------------------------------------------------
CHESSCOLOR CMyClass::GetCurrPlayer()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetCurrPlayer called.");
	return(mychess.GetCurrentPlayer());
}

// ---------------------------------------------------------------------------------
bool CMyClass::MakeMove(char* pMove)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::MakeMove called.");
	return(mychess.ExecuteMove(pMove));
}

// ---------------------------------------------------------------------------------
bool CMyClass::IsValidMove(char* pMove)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::IsValidMove called.");
	return(mychess.IsValidMove(pMove));
}

// ---------------------------------------------------------------------------------
bool CMyClass::IsKingAttacked()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::IsValidMove called.");
	return(mychess.IsKingAttacked());
}

// ---------------------------------------------------------------------------------
bool CMyClass::GetMove(std::wstring wcsCallbackFunction)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetMove called.");
	return(mychess.Go(wcsCallbackFunction));
}

// ---------------------------------------------------------------------------------
int CMyClass::GetStrength()
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetStrength called.");
	return(mychess.GetMaxSearchDepth());
}

// ---------------------------------------------------------------------------------
void CMyClass::SetStrength(int iStrength)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::SetStrength called.");
	mychess.SetMaxSearchDepth(iStrength);
}

// ---------------------------------------------------------------------------------
std::string CMyClass::GetValidMoves(char* pFrom)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetValidMoves called.");
	return(mychess.GetValidMoves(pFrom));
}

// ---------------------------------------------------------------------------------
bool CMyClass::SetPositionsFEN(char* pPositions)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::SetPositionsFEN called.");
	return(mychess.SetPositionsFEN(pPositions));
}

// ---------------------------------------------------------------------------------
std::string CMyClass::GetPositionsFEN(void)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetPositionsFEN called.");
	return(mychess.GetPositionsFEN());
}

// ---------------------------------------------------------------------------------
int CMyClass::GetCalcRunning(void)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetCalcRunning called.");
	return(mychess.GetCalcRunning());
}

// ---------------------------------------------------------------------------------
bool CMyClass::AbortThinking(void)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::AbortThinking called.");
	return(mychess.AbortThinking());
}

// ---------------------------------------------------------------------------------
int CMyClass::GetNumberOfPossibleMoves(void)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetNumberOfPossibleMoves called.");
	return(mychess.GetNumberOfPossibleMoves());
}

// ---------------------------------------------------------------------------------
bool CMyClass::GetMoveProposal(std::wstring wcsCallbackFunction)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"CMyClass::GetMoveProposal called.");
	return(mychess.GoProposal(wcsCallbackFunction));
}



